#include "DLL.CH"
#include "APPEVENT.CH"
#include "XBP.CH"
#include "regclass.ch"
#include "gra.ch"

PROCEDURE Main
   LOCAL nEvent, mp1, mp2, oXbp
   LOCAL oListBox, aStruct, oButton, oStatic
   LOCAL aSubkeys, aValues
   // Create new Registry Object...
   LOCAL oReg := XbpReg():NEW( "HKEY_LOCAL_MACHINE\SOFTWARE\TOMMY1" )
   CLS

   If ! oReg:Status()
      oReg:Create()
   EndIF

   // Get Name of current Key
   ?
   ? "Current Key :", oReg:KeyName
   ?

   oReg:MoveUp()

   // Change current Key (like ChangeDirectory in DOS)
   IF oReg:MoveDown( "Microsoft" )
      ?
      ? [MoveDown("Microsoft") : ], oReg:KeyName

      // Create an array of all existing subkeys
		aSubkeys := oReg:KeyList()
      ?
      ? "press any key to print a list of all subkeys of \SOFTWARE\MICROSOFT"
      INKEY(0)
		AEVAL( aSubkeys, {|aEl| QOUT(aEl)} )
      ?
      ? "press any key to continue"
      INKEY(0)
      CLS

      // Change current Key (like CD..)
      oReg:MoveUp()
      ?
      ? "MoveUp() : ", oReg:KeyName
   ENDIF

   oReg:MoveDown("TOMMY1")
   ?
   ? [MoveDown("TOMMY1") : ], oReg:KeyName

   // Create new Subkey and make it the current one
   oReg:NewKey( "Tommy Software" )
   oReg:MoveDown( "Tommy Software" )

   // ...the same again...
   oReg:NewKey( "Subkey 1" )
   oReg:MoveDown( "Subkey 1" )

   // ...and again <g>
   oReg:NewKey( "Subkey 2" )
   oReg:MoveDown( "Subkey 2" )

   // Add some values, also manipulating the "standard" value
	// The standard value of a registry key is some kind of
	// default value that can be used to store information
	// without adding a new value or subkey
	// Standard is an ACCESS ASSIGN method !
   oReg:Standard := "Tommys first Test"
   ? "Writing some values :"
   ? "Standard value : ", oReg:Standard
	oReg:SetValue( "TEST2", "John Doe" )
	oReg:SetValue( "TEST3", 64 )
   ?
   aValues := oReg:ValueList(.T.)
   AEVAL( aValues, {|aEl| QOUT(aEl)} )

   ?
   ? "You can now watch the result of all the operations with REGEDIT.EXE"
   ?
   ? "Press any key to start RegEdit"
   ?
   ? "Then open :"
   ? "HKEY_LOCAL_MACHINE\SOFTWARE\TOMMY1\Tommy Software\Subkey 1\Subkey 2"
   INKEY(0)

   // start Regedit via RunShell()
   RunShell( "", "REGEDIT.EXE", .T. )

   ?
   ? "Press any key to clean up"
   ? "(after that, press F5 to refresh the display of regedit)"
   ?
   INKEY(0)

   oReg:DelValue("TEST2")
   oReg:DelValue("TEST3")
   oReg:Standard := ""
   // Delete a Subkey and all decendants
   IF oReg:MoveUp()
      ? oReg:KeyName
      oReg:DelKey("Subkey 2")
      IF oReg:MoveUp()
         ? oReg:KeyName
         oReg:DelKey("Subkey 1")
         IF oReg:MoveUp()
            ? oReg:KeyName
            oReg:DelKey("Tommy Software")
            IF oReg:MoveUp()
               ? oReg:KeyName
               oReg:DelKey("TOMMY1")
            ENDIF
         ENDIF
      ENDIF
   ENDIF


   ? "Now something more useful...(press a key)"
   INKEY(0)

   SET COLOR TO "R/W"
   CLS

   oReg := XbpReg():NEW( "HKEY_CURRENT_USER\Control Panel\Desktop" )
   cWallPaper := oReg:GetValue( "Wallpaper" )

   oParent := SetAppWindow()

   // Create OK button
   oButton := XbpPushButton():New( ,, { 10 + 320 + 10, 70}, {120, 40} )
   oButton:Activate := { | uNIL1, uNIL, oSelf | PostAppEvent( xbeP_Close ) }
   oButton:Caption := "OK"
   oButton:Create()

   // Create Static Text
   oStatic := XbpStatic():new( ,, {10, 80 + 290 + 5 } )
   oStatic:AutoSize := .T.
   oStatic:options := XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_WORDBREAK
   oStatic:caption := "Double click to change wallpaper bitmap !"
   oStatic:create()

   // Create Static Text
   oStatic := XbpStatic():new( ,, {10, 20} )
   oStatic:AutoSize := .T.
   oStatic:options := XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_WORDBREAK
   oStatic:caption := "Current Wallpaper : " + TRIM(cWallPaper) + SPACE(60)
   oStatic:create()

   // Create Listbox...
   oListBox := XbpListbox():new()
   oListBox:multiSelection := .T.
   oListBox:ItemSelected := { | uNIL1, uNIL2, oSelf | SetWallPaper( "C:\WINDOWS\"  + TRIM(oSelf:GetItem( oSelf:GetData()[1] )), oStatic ) }
   oListBox:create( ,, {10, 70}, {320, 290} )

   aBitmaps := DIRECTORY( "C:\WINDOWS\*.BMP" )

   ArrayToListbox( oListBox, aBitmaps )

   nPos := ASCAN( aBitMaps, { | aEl | "C:\WINDOWS\" + UPPER(aEl[1]) = UPPER(cWallPaper) } )
   If nPos # 0
      oListBox:SetData( { nPos } )
   EndIF

   SetAppFocus( oListBox )

   // Event loop
   nEvent := 0
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp)
      oXbp:HandleEvent( nEvent, mp1, mp2 )
   ENDDO

   // Remove Xbase-Parts
   aList := oParent:ChildList()
   For nI := 1 TO LEN(aList)
      aList[nI]:Destroy()
   Next

   ?
   ? "Press any key to quit..."
   INKEY(0)


RETURN

FUNCTION ArrayToListBox( oListBox, aArray )
   LOCAL i:=0, imax := Len(aArray)

   IF Valtype( aArray[1] ) == "A"    // 2-dim Array
      DO WHILE ++i <= imax           // Transfer 1st column
         oListBox:addItem( aArray[i,1] )
      ENDDO

   ELSE                              // 1-dim Array
      DO WHILE ++i <= imax           // Trasnfer array elements
         oListBox:addItem( aArray[i] )
      ENDDO
   ENDIF
RETURN oListBox

/*
 * Parameter for SystemParametersInfo()
 */

#define SPI_GETBEEP                 1
#define SPI_SETBEEP                 2
#define SPI_GETMOUSE                3
#define SPI_SETMOUSE                4
#define SPI_GETBORDER               5
#define SPI_SETBORDER               6
#define SPI_GETKEYBOARDSPEED       10
#define SPI_SETKEYBOARDSPEED       11
#define SPI_LANGDRIVER             12
#define SPI_ICONHORIZONTALSPACING  13
#define SPI_GETSCREENSAVETIMEOUT   14
#define SPI_SETSCREENSAVETIMEOUT   15
#define SPI_GETSCREENSAVEACTIVE    16
#define SPI_SETSCREENSAVEACTIVE    17
#define SPI_GETGRIDGRANULARITY     18
#define SPI_SETGRIDGRANULARITY     19
#define SPI_SETDESKWALLPAPER       20
#define SPI_SETDESKPATTERN         21
#define SPI_GETKEYBOARDDELAY       22
#define SPI_SETKEYBOARDDELAY       23
#define SPI_ICONVERTICALSPACING    24
#define SPI_GETICONTITLEWRAP       25
#define SPI_SETICONTITLEWRAP       26
#define SPI_GETMENUDROPALIGNMENT   27
#define SPI_SETMENUDROPALIGNMENT   28
#define SPI_SETDOUBLECLKWIDTH      29
#define SPI_SETDOUBLECLKHEIGHT     30
#define SPI_GETICONTITLELOGFONT    31
#define SPI_SETDOUBLECLICKTIME     32
#define SPI_SETMOUSEBUTTONSWAP     33
#define SPI_SETICONTITLELOGFONT    34
#define SPI_GETFASTTASKSWITCH      35
#define SPI_SETFASTTASKSWITCH      36

#define SPI_SETDRAGFULLWINDOWS     37
#define SPI_GETDRAGFULLWINDOWS     38
#define SPI_GETNONCLIENTMETRICS    41
#define SPI_SETNONCLIENTMETRICS    42
#define SPI_GETMINIMIZEDMETRICS    43
#define SPI_SETMINIMIZEDMETRICS    44
#define SPI_GETICONMETRICS         45
#define SPI_SETICONMETRICS         46
#define SPI_SETWORKAREA            47
#define SPI_GETWORKAREA            48
#define SPI_SETPENWINDOWS          49

#define SPI_GETHIGHCONTRAST        66
#define SPI_SETHIGHCONTRAST        67
#define SPI_GETKEYBOARDPREF        68
#define SPI_SETKEYBOARDPREF        69
#define SPI_GETSCREENREADER        70
#define SPI_SETSCREENREADER        71
#define SPI_GETANIMATION           72
#define SPI_SETANIMATION           73
#define SPI_GETFONTSMOOTHING       74
#define SPI_SETFONTSMOOTHING       75
#define SPI_SETDRAGWIDTH           76
#define SPI_SETDRAGHEIGHT          77
#define SPI_SETHANDHELD            78
#define SPI_GETLOWPOWERTIMEOUT     79
#define SPI_GETPOWEROFFTIMEOUT     80
#define SPI_SETLOWPOWERTIMEOUT     81
#define SPI_SETPOWEROFFTIMEOUT     82
#define SPI_GETLOWPOWERACTIVE      83
#define SPI_GETPOWEROFFACTIVE      84
#define SPI_SETLOWPOWERACTIVE      85
#define SPI_SETPOWEROFFACTIVE      86
#define SPI_SETCURSORS             87
#define SPI_SETICONS               88
#define SPI_GETDEFAULTINPUTLANG    89
#define SPI_SETDEFAULTINPUTLANG    90
#define SPI_SETLANGTOGGLE          91
#define SPI_GETWINDOWSEXTENSION    92
#define SPI_SETMOUSETRAILS         93
#define SPI_GETMOUSETRAILS         94
#define SPI_SCREENSAVERRUNNING     97

#define SPI_GETFILTERKEYS          50
#define SPI_SETFILTERKEYS          51
#define SPI_GETTOGGLEKEYS          52
#define SPI_SETTOGGLEKEYS          53
#define SPI_GETMOUSEKEYS           54
#define SPI_SETMOUSEKEYS           55
#define SPI_GETSHOWSOUNDS          56
#define SPI_SETSHOWSOUNDS          57
#define SPI_GETSTICKYKEYS          58
#define SPI_SETSTICKYKEYS          59
#define SPI_GETACCESSTIMEOUT       60
#define SPI_SETACCESSTIMEOUT       61

#define SPI_GETSERIALKEYS          62
#define SPI_SETSERIALKEYS          63

#define SPI_GETSOUNDSENTRY         64
#define SPI_SETSOUNDSENTRY         65

#define SPI_GETSNAPTODEFBUTTON     95
#define SPI_SETSNAPTODEFBUTTON     96
#define SPI_GETMOUSEHOVERWIDTH     98
#define SPI_SETMOUSEHOVERWIDTH     99
#define SPI_GETMOUSEHOVERHEIGHT   100
#define SPI_SETMOUSEHOVERHEIGHT   101
#define SPI_GETMOUSEHOVERTIME     102
#define SPI_SETMOUSEHOVERTIME     103
#define SPI_GETWHEELSCROLLLINES   104
#define SPI_SETWHEELSCROLLLINES   105

/*
 * Flags
 */
#define SPIF_UPDATEINIFILE    0x0001
#define SPIF_SENDWININICHANGE 0x0002
#define SPIF_SENDCHANGE       SPIF_SENDWININICHANGE

DLLFUNCTION SystemParametersInfoA( nAction, nParam1, @Param2, nWinIni ) USING STDCALL FROM USER32.DLL

FUNCTION SetWallPaper( cBitmap, oStatic )

   IF SystemParametersInfoA( SPI_SETDESKWALLPAPER, 0, @cBitmap, SPIF_SENDCHANGE ) # 0
      oStatic:SetCaption( "Current Wallpaper : " + TRIM(cBitMap) )
   ENDIF

RETURN NIL